<template>
    <div class="order-request-execution">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Изменить"
        :is-loading="isLoading"
        data-qa="ChangeLimitModal"
        @submit="onSubmitHandler"
      >
        <div class="title">Укажите новый лимит</div>
        <div class="row row-inputs">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.tariffLimit"
              label="Текущий лимит"
              :readonly=true
              :subTitle="'₽'"
              placeholder="Введите значение"
              type="money:2"
            />
          </div>
          <div class="col-xs-6">
            <ObInput
              v-model="formData.newTariffLimit"
              label="Новый лимит"
              :subTitle="'₽'"
              placeholder="Введите значение"
              type="money:2"
            />
          </div>
        </div>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          :upload-method="uploadMethod"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'

export default {
  name: 'ChangeLimitModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObInput,
    ObUploader
  },
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    ...mapGetters({}),
    formModel () {
      let _self = this
      return {
        tariffLimit: {
          value: () => _self.order.tariffLimit
        },
        fileUuid: {
          value: ''
        },
        newTariffLimit: {
          value: '',
          validator: {
            required
          }
        }
      }
    },
    uploadMethod () {
      return api.files.postFile
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.fileUuid = null
        return
      }

      this.formData.fileUuid = data.uuid
    },
    async onSubmitHandler (data) {
      try {
        this.isLoading = true
        await api.orderProcess.changeTariffLimit({ uuid: this.order.uuid, ...data })
        this.isLoading = false
        this.$emit('on-submitted')
      } catch (e) {
        console.log(e)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
</style>
